package com.utopiaindustries.selftrucking.Activities.dashboardScreens;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.selftrucking.R;

public class ContainerDetailActivity extends AppCompatActivity {

    TextView containerDetailId, containerDestination, driverId, driverName;
    Button btnMarkPicked;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_container_detail);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        btnMarkPicked.setOnClickListener(v -> {
            Toast.makeText(this, "Container marked as picked", Toast.LENGTH_SHORT).show();

            Intent intent = new Intent(ContainerDetailActivity.this, TrackingActivity.class);
            //intent.putExtra("container_id", container.getContainerId());
            startActivity(intent);

        });
    }

    public void initializeLayout() {
        containerDetailId = findViewById(R.id.container_detail_id);
        containerDestination = findViewById(R.id.container_destination);
        driverId = findViewById(R.id.driver_Id);
        driverName = findViewById(R.id.driver_name);
        btnMarkPicked = findViewById(R.id.btn_mark_picked);

    }
}