package com.utopiaindustries.selftrucking.Activities.dashboardScreens;

import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.lifecycle.ViewModelProvider;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.utopiaindustries.selftrucking.Activities.dashboardScreens.adapters.ContainerAdapter;
import com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice.ApiService;
import com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice.ApiServiceFactory;
import com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice.MotiveApiService;
import com.utopiaindustries.selftrucking.Activities.dashboardScreens.interfaces.SelectListener;
import com.utopiaindustries.selftrucking.models.Container;
import com.utopiaindustries.selftrucking.R;
import com.utopiaindustries.selftrucking.models.ContainerWorkflow;
import com.utopiaindustries.selftrucking.models.DriverResponse;

import java.util.ArrayList;
import java.util.List;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class HomeActivity extends AppCompatActivity implements SelectListener {

    //String[] item = {"Material", "Design", "Components", "Android", "5.0 Lollipop"};
    //AutoCompleteTextView autoCompleteTextView;
    //ArrayAdapter<String> adapterItems;
    HomeViewModel homeViewModel;
    RecyclerView containerRecyclerView;
    ContainerAdapter adapter;
    List<ContainerWorkflow> containerList = new ArrayList<>();
    ApiService apiService;
    MotiveApiService motiveApiService;
    DriverResponse driverResponse;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_home);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        /*autoCompleteTextView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int position, long l) {
                String item = adapterView.getItemAtPosition(position).toString();
                Log.e("Item: ", ""+ item);

            }
        });*/
    }


    public void initializeLayout() {
        homeViewModel = new ViewModelProvider(this).get(HomeViewModel.class);
        containerRecyclerView = findViewById(R.id.container_list);
        containerRecyclerView.setLayoutManager(new LinearLayoutManager(this));
        apiService = ApiServiceFactory.getApiService();
        motiveApiService = ApiServiceFactory.getMotiveApiService();


        driverResponse = (DriverResponse) getIntent().getSerializableExtra("driverResponse");
        assert driverResponse != null;
        containerList.addAll(driverResponse.getContainerWorkflowData());

        //dummyData();

        adapter = new ContainerAdapter(containerList, this);
        containerRecyclerView.setAdapter(adapter);

        /*autoCompleteTextView = findViewById(R.id.auto_complete_textview);
        adapterItems = new ArrayAdapter<String>(this, R.layout.list_items, item);
        autoCompleteTextView.setAdapter(adapterItems);*/
    }

    @Override
    public void onItemClicked(ContainerWorkflow container) {
        Toast.makeText(this, String.valueOf(container.getContainerNo()), Toast.LENGTH_SHORT).show();

        Intent intent = new Intent(HomeActivity.this, ContainerDetailActivity.class);
        intent.putExtra("container_id", container.getContainerNo());
        startActivity(intent);


    }

    /*public void dummyData() {
        Container container1 = new Container("1","Karachi To Lahore","Assigned","11","abc");
        Container container2 = new Container("2","Lahore To Lahore","Assigned","11","abc");
        Container container3 = new Container("3","Islamabad To Lahore","Assigned","11","abc");
        Container container4 = new Container("4","Peshawar To Lahore","Assigned","11","abc");
        Container container5 = new Container("5","Multan To Lahore","Assigned","11","abc");
        Container container6 = new Container("6","Faisalabad To Lahore","Assigned","11","abc");
        Container container7 = new Container("7","Quetta To Lahore","Assigned","11","abc");

        containerList.add(container1);
        containerList.add(container2);
        containerList.add(container3);
        containerList.add(container4);
        containerList.add(container5);
        containerList.add(container6);
        containerList.add(container7);
    }*/

    private void fetchAssignedContainers() {
        apiService.fetchAllReports("").enqueue(new Callback<List<Container>>() {
            @Override
            public void onResponse(Call<List<Container>> call, Response<List<Container>> response) {
                if( response.isSuccessful() && response.body() != null ){

                }
                else {

                }
            }

            @Override
            public void onFailure(Call<List<Container>> call, Throwable t) {
                System.out.println( t.getMessage() );
            }
        });
    }

    private void fetchTruckLocation() {
        motiveApiService.getDriverLocation("").enqueue(new Callback<List<Container>>() {
            @Override
            public void onResponse(Call<List<Container>> call, Response<List<Container>> response) {

            }

            @Override
            public void onFailure(Call<List<Container>> call, Throwable t) {

            }
        });
    }
}