package com.utopiaindustries.selftrucking.Activities.dashboardScreens.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.utopiaindustries.selftrucking.Activities.dashboardScreens.interfaces.SelectListener;
import com.utopiaindustries.selftrucking.models.Container;
import com.utopiaindustries.selftrucking.R;
import com.utopiaindustries.selftrucking.models.ContainerWorkflow;

import java.util.List;

public class ContainerAdapter extends RecyclerView.Adapter<ContainerAdapter.ContainerViewHolder> {

    private List<ContainerWorkflow> containerList;
    private SelectListener listener;

    public ContainerAdapter(List<ContainerWorkflow> containerList, SelectListener listener) {
        this.containerList = containerList;
        this.listener = listener;
    }

    @NonNull
    @Override
    public ContainerViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_container, parent, false);
        return new ContainerViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ContainerViewHolder holder, int position) {
        ContainerWorkflow container = containerList.get(position);
        holder.containerId.setText(container.getContainerNo());
        holder.destination.setText(container.getDestination());
        holder.itemView.setOnClickListener(v -> listener.onItemClicked(container));
    }

    @Override
    public int getItemCount() {
        return containerList.size();
    }

    public interface OnContainerClickListener {
        void onContainerClick(Container container);
    }

    public static class ContainerViewHolder extends RecyclerView.ViewHolder {
        TextView containerId, destination;

        public ContainerViewHolder(@NonNull View itemView) {
            super(itemView);
            containerId = itemView.findViewById(R.id.container_id);
            destination = itemView.findViewById(R.id.container_destination);
        }
    }
}
