package com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice;

import retrofit2.Retrofit;

public class ApiServiceFactory {

    private static ApiService apiService;
    private static MotiveApiService motiveApiService;

    public synchronized static ApiService getApiService() {
        if ( apiService == null ) {
            Retrofit retrofit = RetrofitClient.getClient();
            apiService = retrofit.create( ApiService.class );
        }
        return apiService;
    }

    public synchronized static MotiveApiService getMotiveApiService() {
        if ( motiveApiService == null ) {
            Retrofit retrofit = MotiveClient.getClient();
            motiveApiService = retrofit.create( MotiveApiService.class );
        }
        return motiveApiService;
    }
}
