package com.utopiaindustries.selftrucking.Activities.loginScreens;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.lifecycle.ViewModelProvider;

import com.utopiaindustries.selftrucking.Activities.dashboardScreens.HomeActivity;
import com.utopiaindustries.selftrucking.R;
import com.utopiaindustries.selftrucking.helper.Helper;
import com.utopiaindustries.selftrucking.helper.Preference;

public class LoginActivity extends AppCompatActivity {

    EditText tfEmail, tfPassword;
    Button btnLogin;
    LoginViewModel loginViewModel;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_login);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayouts();

        btnLogin.setOnClickListener(v -> {
            if (isValidate()) {
                loginViewModel.authenticateUser(tfEmail.getText().toString(), tfPassword.getText().toString());
            }
        });

        // Observe the user LiveData for a successful login
        loginViewModel.getUser().observe(this, user -> {
            if (user != null) {
                // Handle successful login (e.g., navigate to another activity)
                Preference.setMyBooleanPref(Helper.project_file, "isLoggedIn", getApplicationContext(), true);
                Log.e("User-Details: ",""+user.toString());
                Toast.makeText(this, "Welcome " + user.getTruckerName(), Toast.LENGTH_SHORT).show();
                Intent intent  = new Intent(this, HomeActivity.class);
                intent.putExtra("driverResponse", user.toString());
                startActivity(intent);
            }
        });

        // Observe the error LiveData for failed login
        loginViewModel.getError().observe(this, error -> {
            if (error != null) {
                Toast.makeText(this, error, Toast.LENGTH_SHORT).show();
            }
        });
    }

    private void initializeLayouts() {
        tfEmail = findViewById(R.id.tf_email);
        tfPassword = findViewById(R.id.tf_password);
        btnLogin = findViewById(R.id.btn_login);

        tfEmail.setText("muhammad.mujtaba");
        tfPassword.setText("Utopia01");

        loginViewModel = new ViewModelProvider(this).get(LoginViewModel.class);

    }

    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        if (tfPassword.getText().toString().isEmpty()) {
            message = "Please enter password.";
            returnValue = false;
        }

        /*if (!Helper.isValidEmail(tfEmail.getText().toString())) {
            message = "Please enter valid email.";
            returnValue = false;
        }*/

        if (tfEmail.getText().toString().isEmpty()) {
            message = "Please enter email.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this,message,Toast.LENGTH_SHORT).show();

        }

        return returnValue;
    }
}