package com.utopiaindustries.selftrucking.Activities.loginScreens;

import android.text.TextUtils;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice.ApiService;
import com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice.ApiServiceFactory;
import com.utopiaindustries.selftrucking.helper.Helper;
import com.utopiaindustries.selftrucking.models.Container;
import com.utopiaindustries.selftrucking.models.DriverResponse;

import java.util.List;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class LoginViewModel extends ViewModel {

    private final MutableLiveData<DriverResponse> userLiveData = new MutableLiveData<>();
    private final MutableLiveData<String> errorLiveData = new MutableLiveData<>();

   // private MutableLiveData<DriverResponse> driverResponse;
    private ApiService apiService;

    public LoginViewModel() {
        //driverResponse = new MutableLiveData<>();
        apiService = ApiServiceFactory.getApiService();
    }

    public void authenticateUser(String user, String password) {

        apiService.isUserAuthenticated(user, password).enqueue(new Callback<DriverResponse>() {
            @Override
            public void onResponse(Call<DriverResponse> call, Response<DriverResponse> response) {
                if (response.isSuccessful()) {
                    userLiveData.setValue(response.body());
                } else {
                    errorLiveData.setValue(response.message());
                }
            }

            @Override
            public void onFailure(Call<DriverResponse> call, Throwable t) {
                errorLiveData.setValue(t.getMessage());
            }
        });
    }

    public LiveData<DriverResponse> getUser() {
        return userLiveData;
    }

    public LiveData<String> getError() {
        return errorLiveData;
    }

    /*public LiveData<Boolean> getIsValid() {
        return isValid;
    }*/

    /*public LiveData<String> getErrorMessage() {
        return errorMessage;
    }*/
}
